import { __decorate } from 'tslib';
import { Injectable, ɵɵdefineInjectable, ɵɵinject, Component, NgModule } from '@angular/core';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { BrowserModule } from '@angular/platform-browser';
import { TranslateService, TranslateModule } from '@ngx-translate/core';

// import { AuthenticationService } from "@digitalmedarbeider/authentication";
// import { HttpHeaderOptions } from "src/app/dtos/http-header-option";
// import { LoaderService } from "../loader.service";
let KGApiService = class KGApiService {
    // httpOptions: HttpHeaderOptions = new HttpHeaderOptions();
    constructor(http) {
        // this.httpOptions.headers = new HttpHeaders({
        //   "Content-Type": "application/json,image/jpg,image/png",
        //   "Access-Control-Allow-Origin": "*",
        //   "Access-Control-Allow-Credentials": "true",
        //   Authorization: "Bearer " + this.authService.getToken(),
        // });
        this.http = http;
    }
    createAuthorizationHeader(headers) {
        return headers;
    }
    loadItems(path) {
        return new Promise((resolve, reject) => {
            this.http
                .get(path)
                .subscribe((response) => {
                resolve(response);
            }, (err) => {
                reject(err);
            }, () => {
                // this.loaderService.hide();
            })
                .add(() => { });
        });
    }
};
KGApiService.ctorParameters = () => [
    { type: HttpClient }
];
KGApiService = __decorate([
    Injectable()
], KGApiService);

let MyDemoLibService = class MyDemoLibService {
    constructor(kgapiservice) {
        this.kgapiservice = kgapiservice;
        this.translation_service_url = 'https://translation-api-dev.azurewebsites.net';
        this._languages_url = this.translation_service_url + "/Translation/code/kgmuadmin/language";
    }
    getLanguages() {
        return this.kgapiservice.loadItems(this._languages_url);
    }
};
MyDemoLibService.ctorParameters = () => [
    { type: KGApiService }
];
MyDemoLibService.ɵprov = ɵɵdefineInjectable({ factory: function MyDemoLibService_Factory() { return new MyDemoLibService(ɵɵinject(KGApiService)); }, token: MyDemoLibService, providedIn: "root" });
MyDemoLibService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], MyDemoLibService);

let MyDemoLibComponent = class MyDemoLibComponent {
    constructor() { }
    ngOnInit() {
    }
};
MyDemoLibComponent = __decorate([
    Component({
        selector: 'lib-my-demo-lib',
        template: `
    <p>
      my-demo-lib works!
    </p>
  `
    })
], MyDemoLibComponent);

let DatatableService = class DatatableService {
    constructor(translate) {
        this.translate = translate;
        const lang = JSON.parse(window.sessionStorage.getItem('lang'));
        if (lang) {
            this.translate.use(lang);
            this.url = "assets/i18n/dt_e.json";
        }
        else {
            this.translate.use('no');
            this.url = "assets/i18n/dt_n.json";
        }
    }
    getUrl() {
        return this.url;
    }
    setUrl(lang) {
        if (lang == 'en') {
            this.url = "assets/i18n/dt_e.json";
        }
        else {
            this.url = "assets/i18n/dt_n.json";
        }
    }
};
DatatableService.ctorParameters = () => [
    { type: TranslateService }
];
DatatableService.ɵprov = ɵɵdefineInjectable({ factory: function DatatableService_Factory() { return new DatatableService(ɵɵinject(TranslateService)); }, token: DatatableService, providedIn: "root" });
DatatableService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], DatatableService);

let LanguageSelectorComponent = class LanguageSelectorComponent {
    constructor(dimeTranslate, translate, dtService) {
        this.dimeTranslate = dimeTranslate;
        this.translate = translate;
        this.dtService = dtService;
        this.languages = [];
        this.preferredLanguage = 'no';
    }
    ngOnInit() {
        this.loadLanguages();
    }
    loadLanguages() {
        this.dimeTranslate.getLanguages().then((response) => {
            this.languages = response.map(resp => this.convertLanguageRespose(resp));
            let lng = this.languages.map(lang => lang.shortCode2);
            if (lng) {
                this.translate.addLangs(lng);
                this.translate.setDefaultLang('no');
                const lang = JSON.parse(window.sessionStorage.getItem('lang'));
                if (lang) {
                    this.translate.use(lang);
                }
                else {
                    this.translate.use(this.preferredLanguage);
                }
            }
        });
    }
    changeLanguage(language) {
        window.sessionStorage.setItem('lang', JSON.stringify(language));
        this.translate.use(JSON.parse(window.sessionStorage.getItem('lang')));
        this.dtService.setUrl(JSON.parse(window.sessionStorage.getItem('lang')));
    }
    convertLanguageRespose(response) {
        const param = {
            shortCode2: response.shortCode2.toLowerCase(),
            nameLocal: response.nameLocal
        };
        return param;
    }
};
LanguageSelectorComponent.ctorParameters = () => [
    { type: MyDemoLibService },
    { type: TranslateService },
    { type: DatatableService }
];
LanguageSelectorComponent = __decorate([
    Component({
        selector: 'lib-language-selector',
        template: "\n\n\n<li _ngcontent-put-c1=\"\" class=\"nav-item dropdown\"><a _ngcontent-put-c1=\"\" aria-expanded=\"false\"\n    aria-haspopup=\"true\" class=\"nav-link dropdown-toggle\" data-toggle=\"dropdown\" href=\"#\" id=\"languageSelector\" style=\"margin-top:-10px\"\n    role=\"button\"> {{ \"SelectLanguage\" | translate }} </a>\n  <div _ngcontent-put-c1=\"\" aria-labelledby=\"languageSelector\" class=\"dropdown-menu bg-dark-blue mt-4 mb-3\"\n    style=\"border-radius:15px;border: 1px solid white;\">\n    <!---->\n    <ng-container *ngFor=\"let lang of languages;let i = index\">\n      <!----><a _ngcontent-put-c1=\"\" class=\"dropdown-item text-white btn\" (click)=\"changeLanguage(lang.shortCode2)\">\n        <img *ngIf=\"lang.shortCode2 == 'en'\" src=\"https://cdn.britannica.com/79/4479-050-6EF87027/flag-Stars-and-Stripes-May-1-1795.jpg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'no'\" src=\"https://www.norden.org/sites/default/files/styles/content_size_800/public/2021-03/Flag_of_Norway.png\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'ar'\" src=\"https://upload.wikimedia.org/wikipedia/commons/b/bb/Arabic-Language-Flag.svg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'ur'\" src=\"https://flagemoji.com/wp-content/uploads/2020/02/Flag_of_Pakistan.svg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'am'\" src=\"https://cdn.britannica.com/12/12-004-A40EEB6F/Flag-Ethiopia.jpg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'so'\" src=\"https://upload.wikimedia.org/wikipedia/commons/thumb/a/a0/Flag_of_Somalia.svg/1200px-Flag_of_Somalia.svg.png\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n          {{\" \"}}{{ lang.nameLocal }}\n      </a>\n      <!---->\n      <div _ngcontent-put-c1=\"\" class=\"dropdown-divider\"></div>\n    </ng-container>\n\n\n  </div>\n</li>\n\n<!-- </ng-container> -->\n<!--  -->\n",
        styles: ["select{background-color:var(--background-primary)!important;border:1px solid #fff;color:var(--white-text-color);padding:3px 5px;border-radius:2px;text-transform:none;word-wrap:normal}.notification{display:none}.bg-dark-blue[_ngcontent-put-c1]{background-color:#707070}.language-select{background-color:var(--background-primary);border:1px solid #fff;color:var(--white-text-color);padding:3px 5px;border-radius:2px}.dropdown-item,.dropdown-toggle{cursor:pointer}.abc::-webkit-scrollbar{display:none;width:0;height:0}.groupHeader{color:var(--background-secondary);text-align:left}.dropdown-header{text-align:left}a:hover{color:#707070}.dropdown-menu a:hover{color:#707070!important}@media screen and (width:320px) and (height:568px){.dropdown-menu-lg{min-width:258px}}"]
    })
], LanguageSelectorComponent);

let MyDemoLibModule = class MyDemoLibModule {
};
MyDemoLibModule = __decorate([
    NgModule({
        declarations: [MyDemoLibComponent, LanguageSelectorComponent],
        imports: [
            TranslateModule.forRoot({}),
            HttpClientModule,
            BrowserModule,
        ],
        exports: [MyDemoLibComponent, LanguageSelectorComponent],
        providers: [
            KGApiService,
        ]
    })
], MyDemoLibModule);

/*
 * Public API Surface of my-demo-lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { LanguageSelectorComponent, MyDemoLibComponent, MyDemoLibModule, MyDemoLibService, KGApiService as ɵa, DatatableService as ɵb };
//# sourceMappingURL=kg-language-selector.js.map
